#ifndef INCL_JID_H
#define INCL_JID_H

/* convenience structs for use within the app */

typedef struct jid_struct
{ /* type=user/resource@server */
    pool p;
    char *resource;
    char *user;
    char *server;
    char *type;
} *jid;

#define JID_RESOURCE 0
#define JID_USER 1
#define JID_SERVER 2
#define JID_TYPE 3
#define JID_FULL 4

jid jid_new(pool p, char *idstr); /* Creates a jabber id from the idstr */
void jid_set(jid id, char *str, int item); /* allows you to individually set jid components */
char *jid_full(jid id); /* builds a string type=user/resource@server from the jid data */
int jid_cmp(jid a, jid b); /* compares two jid's, returns 0 for perfect match */

#endif
