#ifndef INCL_POOL_H
#define INCL_POOL_H

typedef struct pool_struct
{
    int size;
    void *block;
    struct pool_struct *next;
    int key; /* pool-unique external key to find block back */
} _pool, *pool;

pool pool_new(); /* creates a new memory pool */
void *pmalloc(pool p, int size); /* wrapper around malloc, stores pointer to new memory for later reference in the pool */
char *pstrdup(pool p, const char *src); /* wrapper around strdup, gains mem from pool */
void pool_free(pool p); /* frees all the data on the pool and deletes the pool itself */
void *pmalloc_key(pool p, int key, int size); /* key is a unique identifier, searches pool for matching key and returns it or creates new block and sets key, if size=0 it just checks for the key and returns it or NULL */

#endif
