#ifndef INCL_TLISTEN_H
#define INCL_TLISTEN_H

typedef void (*tlisten_onConnect)(thread t, int sock, struct sockaddr_in sa);

typedef struct tlisten
{
     int                         s;	/* Base accept/server socket */
     tlisten_onConnect connect_evt;	/* Function pointer for onConnect event */
     void        *connect_evt_data;	/* Used by onConnect event */
     char                      *ip;
     u_short                  port;
} _tlisten, *tlisten;

/* Creates the tlisten stuct, socket, and thread to accept connects */
thread tlisten_new(u_short port, char *ip, tlisten_onConnect evt, void *evt_data);

/* This is the main loop for the tlisten thread */
static void *_tlisten_main(void *arg);

/* Called when the thread exits to clean up any tlisten data and free the tlisten struct */
static void _tlisten_cleanup(void *arg);

#endif
