#ifndef INCL_TSTREAM_H
#define INCL_TSTREAM_H

typedef int (*tstream_onRead)(void *t, void *buffer, int bufsz);

struct tstream_data
{
        char *data;
        int data_sz;
        int sent;
        struct tstream_data *next;
};

typedef struct tstream_struct
{
     int                     fd;	/* Base file descriptor for the stream */
     tstream_onRead    read_evt;	/* Function pointer for onRead event */
     void        *read_evt_data;	/* Used by onRead event */
     void            *data_aux1;	/* For general purpose usage within thread */
     void            *data_aux2;	/* For general purpose usage within thread */
     void            *data_aux3;	/* For general purpose usage within thread */
     void            *data_aux4;	/* For general purpose usage within thread */
     void            *data_aux5;	/* For general purpose usage within thread */
     struct tstream_data *queue;	/* Queue for storing data to be written to fd by the tid */
} _tstream, *tstream;

/* Creates the tstream struct and starts the thread on the fd */
thread tstream_new(int fd, tstream_onRead evt, void *evt_data);

/* This is the main loop for the tstream thread */
static void *_tstream_main(void *arg);

/* Specifies new data to be written to the fd */
int tstream_write(thread t, void* buffer, int bufsz);

/* Signals the thread to flush the queue, close the fd and quit */
static void _tstream_cleanup(void *arg);

#endif
