#include "jabber/jlib.h"

jid jid_new(pool p, char *idstr)
{
    char *user, *server, *resource, *type, *str;
    jid id;

    if(p == NULL || idstr == NULL)
        return NULL;

    str = pstrdup(p, idstr);

    id = pmalloc(p,sizeof(struct jid_struct));
    id->server = id->user = id->resource = id->type = NULL;
    id->p = p;

    server = strstr(str,"@");
    if(server == NULL)
    { /* if there's no @, it's just the server address */
        id->server = str;
        return id;
    }else{
        *server = '\0';
        ++server;
        id->server = server;
    }

    resource = strstr(str,"/");
    if(resource != NULL)
    {
        *resource = '\0';
        ++resource;
        id->resource = resource;
    }
    
    user = strstr(str,"=");
    if(user != NULL)
    {
        *user = '\0';
        ++user;
        id->user = user;
        id->type = str;
    }else{
        id->user = str;
    }
        
    return id;
}

void jid_set(jid id, char *str, int item)
{
    if(id == NULL)
        return;

    switch(item)
    {
        case JID_RESOURCE:
            id->resource = pstrdup(id->p, str);
            break;
        case JID_USER:
            id->user = pstrdup(id->p, str);
            break;
        case JID_SERVER:
            id->server = pstrdup(id->p, str);
            break;
        case JID_TYPE:
            id->type = pstrdup(id->p, str);
            break;
    }
}

char *jid_full(jid id)
{
    char *ret;
    int size = 0;

    if(id == NULL)
        return NULL;

    if(id->resource != NULL)
        size += strlen(id->resource);
    if(id->user != NULL)
        size += strlen(id->user);
    if(id->server != NULL)
        size += strlen(id->server);
    if(id->type != NULL)
        size += strlen(id->type);

    ret = pmalloc(id->p, size + 4);
    *ret = '\0';
 
    if(id->type != NULL)
    {
        strcat(ret, id->type);
        strcat(ret, "=");
    }
    if(id->user != NULL)
    {
        strcat(ret, id->user);
    }
    if(id->resource != NULL)
    {
        strcat(ret, "/");
        strcat(ret, id->resource);
    }
    strcat(ret, "@");
    strcat(ret, id->server);

    return ret;
}

int jid_cmp(jid a, jid b)
{
    int ret = 0;

    if(a == NULL || b == NULL)
        return -1;

    if(a->resource != NULL)
        ret += j_strcmp(a->resource, b->resource);
    if(a->user != NULL)
        ret += j_strcmp(a->user, b->user);
    if(a->server != NULL)
        ret += j_strcmp(a->server, b->server);
    if(a->type != NULL)
        ret += j_strcmp(a->type, b->type);

    return ret;
}

