#include "jabber/jlib.h"

jpacket jpacket_new(xmlnode x)
{
    jpacket p;
    xmlnode next;

    p = pmalloc(xmlnode_pool(x),sizeof(_jpacket));
    p->x = x;
    p->p = xmlnode_pool(x);
    p->to = p->from = NULL;
    p->flag = 0;
    p->type = JPACKET_UNKNOWN;
    if(j_strcmp(xmlnode_get_name(x),"message") == 0)
        p->type = JPACKET_MESSAGE;
    if(j_strcmp(xmlnode_get_name(x),"presence") == 0)
        p->type = JPACKET_PRESENCE;
    if(j_strcmp(xmlnode_get_name(x),"iq") == 0)
        p->type = JPACKET_IQ;

    next = xmlnode_get_firstchild(x);
    while(next != NULL)
    {
        if(j_strcmp(xmlnode_get_name(next),"to") == 0)
            p->to = jid_new(p->p, xmlnode_get_data(xmlnode_get_firstchild(next)));
        if(j_strcmp(xmlnode_get_name(next),"from") == 0)
            p->from = jid_new(p->p, xmlnode_get_data(xmlnode_get_firstchild(next)));
        next = xmlnode_get_nextsibling(next);
    }

    return p;
}


