#include "jabber/jlib.h"

thread tlisten_new(u_short port, char *ip, tlisten_onConnect evt, void *evt_data)
{
    thread t;
    tlisten tl;
    int s;

    tl = NULL;

    log(LOG_DEBUG,"tlisten_start",ip);

    s = make_netsocket(port, ip, NETSOCKET_SERVER);
    if(s > 0)
    {
        listen(s, 10);
        t = thread_new();

        tl = pmalloc(t->p, sizeof(_tlisten));
        tl->s = s;
        tl->connect_evt = evt;
	tl->connect_evt_data = evt_data;
        tl->port = port;
        tl->ip = j_strdup(ip);

        t->data = (void *)tl;
        t->id = pth_spawn(PTH_ATTR_DEFAULT, _tlisten_main, (void *)t);
    }

    return t;
}

static void *_tlisten_main(void *arg)
{
	/* the guts of the thread, main loop */
	thread t = (thread)arg;
	tlisten tl = (tlisten)(t->data);
        struct sockaddr_in sa;
        size_t sa_size = sizeof(sa);
        int new;

        log(LOG_DEBUG,"_tlisten_main","startup");

	pth_cleanup_push(_tlisten_cleanup, (void *)(t));

        while(1)
        {
            new = pth_accept(tl->s, (struct sockaddr *) &sa, (int *) &sa_size);
            log(LOG_DEBUG,"_tlisten_main","new socket accepted");
            (tl->connect_evt)(t, new, sa);
        }
}

static void _tlisten_cleanup(void *arg)
{
	thread t = (thread)arg;
	tlisten tl = (tlisten)(t->data);

        log(LOG_DEBUG,"tlisten_cleanup",NULL);

	close(tl->s);
	thread_free(t);
}
